/*
 * lab0.c
 *
 */

#include "usart.c"

#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>

/* definitii note (in hertzi) */
#define c    261
#define d    294
#define e    329
#define f    349
#define g    391
#define gS   415
#define a    440
#define aS   455
#define b    466
#define cH   523
#define cSH  554
#define dH   587
#define dSH  622
#define eH   659
#define fH   698
#define fSH  740
#define gH   784
#define gSH  830
#define aH   880

void timer1_start(void)
{
    TCCR1A |= (1 << COM1A0) | (1 << COM1B0);
    TCCR1B |= (5 << CS10) | (1 << WGM12);

    OCR1B = 0;
    OCR1A = 0;
}


uint16_t get_value(char chr){

	switch(chr){
		case 'c':
			return 16000000 / 1024 / 2/c;
		case 'd':
			return 16000000 / 1024 / 2/d;
		case 'e':
			return 16000000 / 1024 / 2/e;
		case 'f':
			return 16000000 / 1024 / 2/f;
		case 'g':
			return 16000000 / 1024 / 2/g;
		case 'a':
			return 16000000 / 1024 / 2/a;
		case 'b':
			return 16000000 / 1024 / 2/b;
		case 'h':
			return 16000000 / 1024 / 2/gS;
		case 'i':
			return 16000000 / 1024 / 2/aS;
		case 'j':
			return 16000000 / 1024 / 2/cH;
		case 'k':
			return 16000000 / 1024 / 2/dH;
		case 'l':
			return 16000000 / 1024 / 2/eH;
		case 'm':
			return 16000000 / 1024 / 2/fH;
		case 'n':
			return 16000000 / 1024 / 2/gH;
		case 'o':
			return 16000000 / 1024 / 2/aH;
		case 'p':
			return 16000000 / 1024 / 2/cSH;
		case 'q':
			return 16000000 / 1024 / 2/dSH;
		case 'r':
			return 16000000 / 1024 / 2/fSH;
		case 's':
			return 16000000 / 1024 / 2/gSH;


				
		}

}
char playing = ' ';

void play_note(char chr){
	
	if(chr == ' '){
		
		playing = chr;
		PORTD &= ~(1 << PD7); // shut down the led 
		DDRD &= ~(1 << PD5); // shut down the buzzer
		return;
	}
	if(playing == chr) // continue note
		return;
	playing = chr;
	DDRD |= (1<<PD5); // restart the buzzer
	uint16_t new_top;
	new_top = get_value(chr);
	PORTD |= (1 << PD7); // turn up the led
	TCNT1 = 0;
	OCR1B = (uint32_t)new_top * OCR1B / OCR1A;
	OCR1A = new_top;
}
void bluetooth_play() {
	
	char chr;
	int i;

	// bluetooth communication
	DDRD &= ~(1<<PD0);
	
	UCSR0B = ((1<<TXEN0) | (1<<RXEN0) | (1<<RXCIE0)); //read write + interrupt
	
	/* seteaza formatul frame-ului: 8 biti de date, 1 bit de stop, fara paritate */

	UCSR0C = (1<<USBS0) | (1<<UCSZ00) | (1<<UCSZ01);
	
	UBRR0 = 0x0067; // imi modific propriul baud rate
	
	DDRD |= (1<<PD7);
	while(1){
		chr = USART0_receive();
		
		if(chr == '*'){ // check if it is a melody
			char buf[1000];
			for(i = 0;i < 100;i++){ // record melody in buffer
				buf[i] = USART0_receive();
				if(buf[i] == '*'){
					break;
				}
			}
			for(i = 0; buf[i] != '*'; ++i) { // play melody
				play_note(buf[i]);
				_delay_ms(100);
				
			}
			DDRD &= ~(1 << PD5);
		}
		else 
			play_note(chr); // play simple note
	}
	
}



int main(void) {
	timer1_start();
	bluetooth_play();
	
	return 0;
}

